﻿Imports System.Collections.ObjectModel
Imports System.ComponentModel
Imports System.Data
Imports System.Data.OleDb

Public Class MainViewModel
    Implements INotifyPropertyChanged

    'Private cvsKart As CollectionViewSource
    'Public view1 As New ListCollectionView(New UrgentOrders)

    'Private KartView As New ListCollectionView(New UrgentOrders)
    Private lcvKart As ListCollectionView
    Private lcvCortini1 As ListCollectionView
    Private lcvCortini_2 As ListCollectionView
    Private lcvCortini_3 As ListCollectionView
    Private lcvTourHaas As ListCollectionView
    Private lcvMac As ListCollectionView
    Private lcvMill As ListCollectionView
    Private cvs As CollectionViewSource 'SapOrdersView
    Dim dtCurrentProductionOrders As DataTable

    Sub New()
        'If cvsCortini_1 Is Nothing Then
        '    cvsCortini_1 = New CollectionViewSource
        '    cvsCortini_1.Source = New UrgentOrders
        '    cvsCortini_1.View.MoveCurrentToFirst()
        'End If
        AddHandler Me.Kart_View.CurrentChanged, AddressOf Me.UrgentOrdersLists_CurrentChanged
        AddHandler Me.Cortini1_View.CurrentChanged, AddressOf Me.UrgentOrdersLists_CurrentChanged
        AddHandler Me.Cortini2_View.CurrentChanged, AddressOf Me.UrgentOrdersLists_CurrentChanged
        AddHandler Me.Cortini3_View.CurrentChanged, AddressOf Me.UrgentOrdersLists_CurrentChanged
    End Sub

    Private Sub UrgentOrdersLists_CurrentChanged(ByVal sender As Object, ByVal e As EventArgs)
        UrgentOrderSelected(sender)
    End Sub

    Private Sub UrgentOrderSelected(selection As ICollectionView)
        SelectedUrgentOrder = selection.CurrentItem
    End Sub

#Region "View properties"
    Public ReadOnly Property SapOrdersView() As ICollectionView
        Get
            If cvs Is Nothing Then
                cvs = New CollectionViewSource
                GetCurrentOrders()
                ''dtCurrentProductionOrders.DefaultView.RowFilter = "QTE < 50"
                ''dtCurrentProductionOrders.DefaultView.RowFilter = "NOT [Material Number] = " & SelectedArticle 
                '-09/12/2017-ElseIf Not RowFilterHasBeenReset Then
                '-09/12/2017-dtCurrentProductionOrders.DefaultView.RowFilter = "[Material Number] = " & SelectedArticle 'NOT 'art.ToString
            End If

            cvs.Source = dtCurrentProductionOrders.DefaultView ''.RowFilter = "" 'New Asterix
            Return cvs.View
        End Get
    End Property

    'Public ReadOnly Property cvsWkcList_View() As ICollectionView 'ObservableCollection(Of UrgentOrders)
    '    Get
    '        If cvsWkcList Is Nothing Then
    '            cvsWkcList = New CollectionViewSource
    '            cvsWkcList.Source = New UrgentOrders
    '        End If
    '        'If (_Contacts Is Nothing) Then
    '        '    _Contacts = New ObservableCollection(Of ContactViewModel)
    '        'End If
    '        'cvsWkcList.View.Filter = Function(obj As Object)
    '        '                              If obj Is Nothing Then
    '        '                                  Return False
    '        '                              Else
    '        '                                  With CType(obj, UrgerntOrder)
    '        '                                      Return .Wkc = WorkCenter.Cortini_1
    '        '                                  End With
    '        '                              End If
    '        '                          End Function
    '        'Return cvsWkcList.View
    '        Return view1

    '    End Get
    'End Property

    'Private selectedOrderValue As UrgentOrders '"= EMPTY"
    'Public Property SelectedOrder() As UrgentOrders

    '    Get
    '        Return Me.selectedOrderValue
    '    End Get

    '    Set(ByVal value As UrgentOrders)

    '        ' If Not (value <> selectedOrderValue) Then
    '        Me.selectedOrderValue = value
    '        cvsWkcList.View.MoveCurrentTo(selectedOrderValue)
    '        '= Function(obj As Object)
    '        '                         If obj Is Nothing Then
    '        '                             Return False
    '        '                         Else
    '        '                             With CType(obj, UrgerntOrder)
    '        '                                 Return .Wkc = WorkCenter.Cortini_1
    '        '                             End With
    '        '                         End If
    '        '                     End Function
    '        OnPropertyChanged("SelectedOrder")
    '        'RowFilterHasBeenReset = False
    '        'OnPropertyChanged("cvsWkcList_View")
    '        'End If
    '    End Set

    'End Property

    'Used to bind selected urgent order to the Textbox

    Private _selectedUrgentOrder As UrgentOrder
    Public Property SelectedUrgentOrder() As UrgentOrder
        Get
            'If _selectedUrgentOrder Is Nothing Then
            '    _selectedUrgentOrder = CType(cvsCortini_1.View.CurrentItem, UrgentOrder)
            'End If
            Return _selectedUrgentOrder

        End Get
        Set(ByVal value As UrgentOrder)
            _selectedUrgentOrder = value
            OnPropertyChanged("SelectedUrgentOrder")
        End Set

    End Property

    Public ReadOnly Property Kart_View() As ICollectionView
        Get
            If lcvKart Is Nothing Then
                lcvKart = New ListCollectionView(New UrgentOrders)
            End If

            lcvKart.Filter = Function(obj As Object)
                                 If obj Is Nothing Then
                                     Return False
                                 Else
                                     With CType(obj, UrgentOrder)
                                         Return .Wkc = WorkCenter.Kart
                                     End With
                                 End If
                             End Function
            Return lcvKart

        End Get
    End Property

    Public ReadOnly Property Cortini1_View() As ICollectionView
        Get

            If lcvCortini1 Is Nothing Then
                lcvCortini1 = New ListCollectionView(New UrgentOrders)  'cvsCortini_1.Source = New UrgentOrders
            End If

            lcvCortini1.Filter = Function(obj As Object)
                                     If obj Is Nothing Then
                                         Return False
                                     Else
                                         With CType(obj, UrgentOrder)
                                             Return .Wkc = WorkCenter.Cortini_1
                                         End With
                                     End If
                                 End Function
            Return lcvCortini1

        End Get
    End Property

    Public ReadOnly Property Cortini2_View() As ICollectionView
        Get
            If lcvCortini_2 Is Nothing Then
                lcvCortini_2 = New ListCollectionView(New UrgentOrders)
                'Cortini_2View.Source = New UrgentOrders
            End If
            lcvCortini_2.Filter = Function(obj As Object)
                                      If obj Is Nothing Then
                                          Return False
                                      Else
                                          With CType(obj, UrgentOrder)
                                              Return .Wkc = WorkCenter.Cortini_2
                                          End With
                                      End If
                                  End Function
            Return lcvCortini_2

        End Get
    End Property

    Public ReadOnly Property Cortini3_View() As ICollectionView
        Get
            If lcvCortini_3 Is Nothing Then
                lcvCortini_3 = New ListCollectionView(New UrgentOrders)
                'Cortini_2View.Source = New UrgentOrders
            End If

            lcvCortini_3.Filter = Function(obj As Object)
                                      If obj Is Nothing Then
                                          Return False
                                      Else
                                          With CType(obj, UrgentOrder)
                                              Return .Wkc = WorkCenter.Cortini_3
                                          End With
                                      End If
                                  End Function
            Return lcvCortini_3
        End Get
    End Property

    Public ReadOnly Property TourHaas_View() As ICollectionView
        Get
            If lcvTourHaas Is Nothing Then
                lcvTourHaas = New ListCollectionView(New UrgentOrders)            'cvsTourHaas.Source = New UrgentOrders
            End If
            lcvTourHaas.Filter = Function(obj As Object)
                                     If obj Is Nothing Then
                                         Return False
                                     Else
                                         With CType(obj, UrgentOrder)
                                             Return .Wkc = WorkCenter.Tour_Haas
                                         End With
                                     End If
                                 End Function
            Return lcvTourHaas

        End Get
    End Property

    Public ReadOnly Property Mac_View() As ICollectionView
        Get
            If lcvMac Is Nothing Then
                lcvMac = New ListCollectionView(New UrgentOrders)
            End If

            lcvMac.Filter = Function(obj As Object)
                                If obj Is Nothing Then
                                    Return False
                                Else
                                    With CType(obj, UrgentOrder)
                                        Return .Wkc = WorkCenter.Mac
                                    End With
                                End If
                            End Function
            Return lcvMac
        End Get
    End Property

    Public ReadOnly Property Fraisage_View() As ICollectionView
        Get
            If lcvMill Is Nothing Then
                lcvMill = New ListCollectionView(New UrgentOrders)
            End If

            lcvMill.Filter = Function(obj As Object)
                                 If obj Is Nothing Then
                                     Return False
                                 Else
                                     With CType(obj, UrgentOrder)
                                         Return .Wkc = WorkCenter.Fraiseuse
                                     End With
                                 End If
                             End Function
            Return lcvMill
        End Get
    End Property
#End Region


#Region "Extract data from Excel files."

    Sub GetCurrentOrders()

        Dim conn As New OleDbConnection
        Dim salesReader As OleDbDataReader
        Dim connString As String
        Dim cmd As New OleDbCommand

        dtCurrentProductionOrders = New DataTable

        Try

            REM Connection is not working if HDR is stet to YES!
            connString = "Data Source=" &
                "C:\File path here\MyExcelFile.xlsm;" &
                "Provider=Microsoft.ACE.OLEDB.12.0;" &
                "Extended Properties=""Excel 12.0 Macro;HDR=NO"";"

            ' Open the connection.
            conn.ConnectionString = connString
            conn.Open()

            'Set the command properties.
            cmd.Connection = conn

            cmd.CommandText = "SELECT F1 as [OF], F3 as [Sem], F4 as [Material description], F5 as [Client], F6 as [QTE]," &
            " F14 as [Material], F16 as [Work center], F17 as [Dernier pointage], F30 as [Finish], F31 as [Remarques IPC] FROM [Charge$]"

            ' cmd.CommandText = "SELECT [0], [QTE], [Material description], [Material Number]," &
            ' " [ Opération Dernier Pointage], [Work Center Dernier Pointage] FROM [Charge$]" '-09/12/2017- WHERE Client Like '%Cerobear%'   ''''' WHERE Article=6228855

            ' Get the OleDbDataReader and do some processing with it.
            salesReader =
                cmd.ExecuteReader(CommandBehavior.CloseConnection)
            Try
                'While (salesReader.Read)
                'Process data.
                'Dim dataRow As DataRow = dtCurrentProductionOrders.NewRow
                'End While
                Do Until salesReader.IsClosed
                    dtCurrentProductionOrders.Load(salesReader)
                Loop
                For Each c As DataColumn In dtCurrentProductionOrders.Columns
                    If c.ColumnName = " Opération Dernier Pointage" Then  REM Remove the "leading" space character of the column name. 
                        c.ColumnName = LTrim(c.ColumnName)                REM No Data displayed in this column when space character not removed!
                        Exit For
                    End If
                Next
                REM Delete the first row ot the Excel sheet that contains the column names!
                dtCurrentProductionOrders.Rows.Item(0).Delete()
            Finally
                salesReader.Close()
            End Try

        Catch ex As Exception
            'Error handling
        End Try
        OrdersCount = dtCurrentProductionOrders.Rows.Count
    End Sub
#End Region

#Region "Basic Properties"
    Private ordersCountValue As Integer
    Public Property OrdersCount() As Integer
        Get
            Return ordersCountValue
        End Get
        Set(ByVal value As Integer)
            ordersCountValue = value
            OnPropertyChanged("OrdersCount")
        End Set
    End Property

#End Region

#Region "Notification mecanism"
    Public Event PropertyChanged(ByVal sender As Object, ByVal e As System.ComponentModel.PropertyChangedEventArgs) _
        Implements System.ComponentModel.INotifyPropertyChanged.PropertyChanged

    Private Sub OnPropertyChanged(ByVal prop As String)
        RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs(prop))
    End Sub
#End Region

End Class
