﻿Imports System.Collections.ObjectModel

Public Class PriorityOrders

End Class

Public Class UrgentOrders
    Inherits ObservableCollection(Of UrgentOrder)

    Public Sub New()
        Me.Add(New UrgentOrder With {.OrderNbr = 9338054, .ArticleNbr = 12214367, .NbrPieces = 250, .MaterialDescription = "CTBB 25,400  (1'')  G10  SNCB5", .RemarquesIPC = "bla-bla-Bla", .DateConfirm = "26/01/2018", .Wkc = WorkCenter.Cortini_1})
        Me.Add(New UrgentOrder With {.OrderNbr = 9338073, .ArticleNbr = 12214382, .NbrPieces = 250, .MaterialDescription = "CTBB 28,570  (1 1/8'')  G10  SNCB5", .RemarquesIPC = "Nouveau délais", .DateConfirm = "26/01/2018", .Wkc = WorkCenter.Kart})
        Me.Add(New UrgentOrder With {.OrderNbr = 9392592, .ArticleNbr = 12240356, .NbrPieces = 8, .MaterialDescription = "Keramik-Walze 5667-5-082603 SNC1", .RemarquesIPC = "8 anneaux à livrer", .DateConfirm = "12/12/2018", .Wkc = WorkCenter.Cortini_2})
        Me.Add(New UrgentOrder With {.OrderNbr = 9416729, .ArticleNbr = 12172036, .NbrPieces = 4, .MaterialDescription = "SAPA PRECISION TUBING n.v. ", .RemarquesIPC = "Sliptechink", .DateConfirm = "24/12/2018", .Wkc = WorkCenter.Cortini_1})
        Me.Add(New UrgentOrder With {.OrderNbr = 9423407, .ArticleNbr = 12170685, .NbrPieces = 240, .MaterialDescription = "WNGX 080416TN-020D-C (98291) roh CTN3105", .RemarquesIPC = "Annullé", .DateConfirm = "23/01/2018", .Wkc = WorkCenter.Cortini_2})
        Me.Add(New UrgentOrder With {.OrderNbr = 9414089, .ArticleNbr = 6291400, .NbrPieces = 525, .MaterialDescription = "CTBB 10,500  EGO  SNCB5", .RemarquesIPC = "Billes Fritsch, encore 2 partielles à livrer", .DateConfirm = "19/01/2018", .Wkc = WorkCenter.Kart})
        Me.Add(New UrgentOrder With {.OrderNbr = 9445522, .ArticleNbr = 12170682, .NbrPieces = 800, .MaterialDescription = "SNNX 120716TN-020D-C roh  CTN3105", .RemarquesIPC = "Passer en rohling", .DateConfirm = "16/03/2018", .Wkc = WorkCenter.Cortini_3})
    End Sub

End Class

Public Class UrgentOrder
    Public Property OrderNbr As Integer
    Public Property ArticleNbr As Integer
    Public Property NbrPieces As Integer
    Public Property MaterialDescription As String
    Public Property RemarquesIPC As String
    Public Property DateConfirm As Date
    Public Property Wkc As WorkCenter
    Public Property Customer As String

End Class

Public Enum WorkCenter
    Kart
    Cortini_1
    Cortini_2
    Cortini_3
    Tour_Haas
    Mac
    Fraiseuse
    Compression
End Enum